angular.module('starter.controllers', [])

.controller('GradebookCtrl', function($scope, $ionicModal, $ionicListDelegate, Semester, Semesters, DBackUp) {
    // delete semesters
    $scope.data = {
        showDelete: false
    }
	
    // init modal
    $ionicModal.fromTemplateUrl('new-semester.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });

    //open modal
    $scope.openModal = function() {
        $scope.modal.show();
    };

    //close modal
    $scope.closeModal = function() {
        $scope.modal.hide();
    };

    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
    });
    // Execute action on hide modal
    $scope.$on('modal.hidden', function() {
        // Execute action
    });

    //when we write this sql code we will order by year in asc
    $scope.semesters = Semesters;
    //Semester.loadSemesters($scope.semesters);
    //save a new semester
    $scope.newSemester = function(cat) {
        if (cat.checked) {
            Semester.newSemester(cat.semesterName, $scope.semesters, cat.semesterYear);
        } else {
            var date = new Date();
            var year = date.getFullYear();
            Semester.newSemester(cat.semesterName, $scope.semesters, year);
        }
        $scope.closeModal();
        cat.semesterName = "";
        cat.semesterYear = "";
        cat.checked = false;
    }

    //selected semester
    $scope.selectedSemester;

    //delete a semester
    $scope.deleteSemester = function(semester) {

        $scope.selectedSemester = semester;

        navigator.notification.confirm(
            'Are you sure you want to remove ' + semester.name + '?',
            confirmRemoveSemester,
            'Delete', ['Cancel', 'Yes']
        );

        function confirmRemoveSemester(buttonIndex) {
            if (buttonIndex == 2) {
                Semester.deleteSemester($scope.selectedSemester.id);
                $scope.semesters[$scope.selectedSemester.year].splice($scope.semesters[$scope.selectedSemester.year].indexOf($scope.selectedSemester), 1);
                $scope.$apply(function() {
                    $ionicListDelegate.showDelete(false);
                    $scope.data.showDelete = false;
                })
            }
        }
    }
	
	$scope.semestersLength = function (obj) {
		return Object.keys(obj).length === 0;
	}
})

.controller('ClassCtrl', function($scope, $stateParams, Class, Classes, $ionicModal, $ionicNavBarDelegate, $ionicListDelegate) {
    $scope.goBack = function() {
        $ionicNavBarDelegate.back();
    };
    // delete classes
    $scope.data = {
        showDelete: false
    }

    //handle route params
    $scope.semesterId = $stateParams.semesterId;
    $scope.semesterName = $stateParams.semesterName;
    $scope.semesterYear = $stateParams.semesterYear;

    //update semester year and name
    $scope.nameChange = function(name, year) {
        $scope.semesterName = name;
        $scope.semesterYear = year;

        Class.updateName($scope.semesterId, name, year);
    }

    //set up modal logic
    $ionicModal.fromTemplateUrl('new-class.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });

    $scope.openModal = function() {
        $scope.modal.show();
    };

    $scope.closeModal = function() {
        $scope.modal.hide();
    };

    //holds this instance semester's classes
    $scope.classes = Classes;
    $scope.selectedClass;

    //Class.loadClasses($scope.semesterId, $scope.classes);
    //alert(JSON.stringify($scope.classes));

    //save a new class
    $scope.newClass = function(newclass) {
        $scope.closeModal();
        Class.newClass(newclass.name, $scope.semesterId, $scope.classes);
        newclass.name = "";
    }

    //remove a class
    $scope.deleteClass = function(classObj) {
        $scope.selectedClass = classObj;
        navigator.notification.confirm(
            'Are you sure you want to remove ' + classObj.name + '?',
            confirmRemoveClass,
            'Delete', ['Cancel', 'Yes']
        );
    }

    function confirmRemoveClass(buttonIndex) {
        if (buttonIndex == 2) {
            $scope.$apply(function() {
                Class.deleteClass($scope.selectedClass.id);
                $scope.classes.splice($scope.classes.indexOf($scope.selectedClass), 1);

                $ionicListDelegate.showDelete(false);
                $scope.data.showDelete = false;
            });
        }
    }
})

.controller('CategoryCtrl', function($scope, Category, ClassInfo, $stateParams, $ionicModal, Settings, $location, $timeout, $ionicNavBarDelegate, $ionicListDelegate) {
    //custom go back
    $scope.goBack = function() {
        $ionicNavBarDelegate.back();
    };
    //route parameters
    $scope.classId = $stateParams.classId;
    $scope.className = $stateParams.className;

	//view booleans
    $scope.data = {
        weight: false,
        edit: false,
		weightLeft: 100
    };

    // init modal
    $ionicModal.fromTemplateUrl('new-category.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });

    //show modal
    $scope.openModal = function() {
        var lessThan = false;
        for (var i = 0; i < $scope.pieData[0].data.length; i++) {
            if ($scope.pieData[0].data[i].cat_id == -1) {
                lessThan = true;
				$scope.data.weightLeft = parseFloat($scope.pieData[0].data[i].y);
                break;
            }
        }
        if (lessThan) {
            $scope.modal.show();
        } else {
            navigator.notification.alert(
                'All your categories add up to 100% weight. You may only add Extra Credit Items.',
                null,
                'All Filled Up!'
            );
        }
    };

    //close modal
    $scope.closeModal = function() {
			$scope.modal.hide();
    };

    //change class name
    $scope.nameChange = function(name) {
        $scope.semesterName = name;
        Category.updateName($scope.classId, name);
    }
	
	$scope.grade = ClassInfo.grade.toFixed(2);

    //class chart data
    $scope.pieData = [{
        name: 'Weight',
        data: ClassInfo.categories
    }];

    //save new category
    $scope.newCategory = function(cat) {
		if(cat.weight > $scope.data.weightLeft){
			navigator.notification.alert(
				'The weight you tried to enter is too large.\nPercentage left: ' + $scope.data.weightLeft,
				null,
				'Too much weight!!'
			);
		} else {
			cat.checked = 0;
			console.log('extra cred: ' + cat.checked);
			Category.newCat(cat, $scope.classId, $scope.pieData[0].data, $location, $timeout);
			$scope.closeModal();
		}
    };

    //chart handle
   
	
         $('#container').highcharts({
            chart: {
                backgroundColor: '#FFFBF0',
                plotBackgroundColor: '#FFFBF0',
                plotBorderWidth: null,
                plotShadow: false,
                marginTop: 0,
                type: 'pie'
            },
            title: {
                text: ''
            },
            exporting: {
                enabled: false
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            legend: {
                y: -90,
                labelFormatter: function() {
                    return this.name + ": " + this.percentage.toFixed(2) + "%";
                }
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    borderColor: '#fff',
					size: '70%',
                    dataLabels: {
                        enabled: Settings.useChartLabels() == "true" ? true : false,
                        distance: 5,
                        formatter: function() {
                            return '<b>' + this.point.name + (Settings.usePercentageLabels() == "true" ? ": " + this.percentage + "%" : "") + '<b/>';
                        }
                    },
                    showInLegend: true,
                    events: {
                        click: function(event) {
                            //load this id maybe? after double click... hmm
                            var name = event.point.name;
                            var id = event.point.cat_id;
                            if (id < 0) {
                                navigator.notification.alert(
                                    'Have you added your homeworks yet?? :)',
                                    null,
                                    'Uh oh'
                                );
                            } else {
                                $timeout(function() {
                                    $location.path('/app/category-detail/' + id + '/' + name);
                                });
                            }
                        }
                    }
                },
				series: {
					point: {
						events: {
							legendItemClick: function () {
								return false; // <== returning false will cancel the default action
							}
						}
					}
				}
            },
            series: $scope.pieData,
            credits: {
                enabled: false
            }
        });

})

.controller('singleCatCtrl', function($scope, singleCategory, Category, $stateParams, $ionicNavBarDelegate, $timeout, $ionicListDelegate, $state) {
    //custom go back
    $scope.goBack = function() {
        Category.update($scope.catId, $scope.self).then(function() {
			$ionicNavBarDelegate.back();
		}, function(err){
			console.log(err);
		});
    };
    //route parameters
    $scope.catId = $stateParams.catId;
    $scope.catName = $stateParams.catName;

    //this category object
    $scope.self = singleCategory;

	$scope.editPoints = function () {
		Category.update($scope.catId, $scope.self).then(function() {
			$state.go("app.points", {"catId": $scope.catId, "catName": $scope.catName});
		});
	}

    //remove category
    $scope.remove = function() {
        navigator.notification.confirm(
            'Are you sure you want to delete ' + $scope.catName + '?',
            confirmDelete,
            'Delete Category', ['Cancel', 'Yes']
        );
    }

    function confirmDelete(buttonIndex) {
        if (buttonIndex == 2) {
            Category.deleteCat($scope.catId);
            $timeout(function() {
                $ionicNavBarDelegate.back();
            });
        }
    }
	
	//catch if they leave
	$scope.$on("$destroy", function(){
		 Category.update($scope.catId, $scope.self).then(function () {
			console.log('finished saving the cat');
		 }, function(err){
			console.log(err);
		 });
    });
})

.controller('extraCreditCtrl', function ($scope, extraCredit, Category, $ionicNavBarDelegate, Settings, $ionicModal, $stateParams, $location, $timeout){
	$scope.classId = $stateParams.classId;
	
	$scope.goBack = function() {
		$ionicNavBarDelegate.back();
    };
	
	// init modal
    $ionicModal.fromTemplateUrl('new-EC.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
	
	$scope.newEC = function(cat){
		cat.checked = 1;
		console.log('extra credit is: ' + cat.checked);
		Category.newCat(cat, $scope.classId, $scope.extraCredit, $location, $timeout);
		$scope.modal.hide();
	}
	
	$scope.hints = Settings.useHints();
	
	$scope.extraCredit = extraCredit;
	
	//close modal
    $scope.closeModal = function() {
		$scope.modal.hide();
    };
	
	$scope.openModal = function () {
		$scope.modal.show();
	}
	
	//Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
    });
})

.controller('pointsCtrl', function ($scope, $stateParams, $ionicNavBarDelegate, $ionicListDelegate, Points, Category, Settings) {
	$scope.catName = $stateParams.catName;
	$scope.catId = $stateParams.catId;
	
	$scope.data = {
		reorder: false
	}
	
	$scope.hints = Settings.useHints();
	
	$scope.chosenGradeIndex;
	
	$scope.points = Points;
	
	$scope.goBack = function() {
		 Category.update($scope.catId, $scope.points).then(function () {
			$ionicNavBarDelegate.back();
		 }, function(err){
			console.log(err);
		 });
    };
	
	//edit earned score
	$scope.editGrade = function(grade){
		$scope.chosenGradeIndex = $scope.points.data.indexOf(grade);
		navigator.notification.prompt(
			'Enter the new points.',
			confirmEdit,
			'Edit',
			['Cancel', 'Save'],
			(grade.earned).toString()
		);
		
		
		//need to check for bad number here
		function confirmEdit(results){
			if(results.buttonIndex == 2){
				var points = results.input1;
				if(isNumber(points)){
					changePoints($scope.chosenGradeIndex, parseFloat(results.input1));
					$ionicListDelegate.closeOptionButtons();
				} else {
					navigator.notification.alert(
						'Please enter a valid number.',
						null,
						'Uh oh'
					);
				}
			}
		}
	}
	
	//add a new earned score
    $scope.addEarned = function() {
        var block = {
            earned: ''
        };
        $scope.points.data.push(block);
    }

    //delete score
    $scope.deleteGrade = function(grade) {
        $scope.points.data.splice($scope.points.data.indexOf(grade), 1);
		$ionicListDelegate.closeOptionButtons();
    }
	
	$scope.reorderItem = function(point, fromIndex, toIndex) {
		$scope.points.data.splice((fromIndex-1), 1);
		$scope.points.data.splice((toIndex-1), 0, point);
	};
	
	//utility methods
	function changePoints(index, val){
		$scope.$apply(function () {
			$scope.points.data[index].earned = val;
		});
	}
	
	function isNumber(n) {
		return !isNaN(parseFloat(n)) && isFinite(n);
	}
	
	//catch if they leave
	$scope.$on("$destroy", function(){
		 Category.update($scope.catId, $scope.points).then(function () {
			console.log('finished saving the cat');
		 }, function(err){
			console.log(err);
		 });
    });
})

.controller('ExtraCreditCtrl', function($scope){

})

.controller('IAPCtrl', function($scope, IAP, $ionicNavBarDelegate){
	//custom go back
    $scope.goBack = function() {
        $ionicNavBarDelegate.back();
    };
	
	IAP.startWatch();
	
	$scope.iap = IAP.getProduct();
	
	$scope.purchase = function (id){
		IAP.buy(id);
	}
	
	$scope.$on("$destroy", function(){
		IAP.stopWatch();
	});
})

.controller('SettingsCtrl', function($scope, Settings, $ionicNavBarDelegate, DBackUp) {
    //custom go back
    $scope.goBack = function() {
        $ionicNavBarDelegate.back();
    };

    $scope.toggleList = [{
        text: "Labels",
        checked: Settings.useChartLabels() == "true" ? true : false
    }, {
        text: "Show Weight",
        checked: Settings.usePercentageLabels() == "true" ? true : false
    }];
	
	$scope.autoBackups = {
		text:"Automatic Backups",
		checked: Settings.useAutoBackups()
	}
	
	$scope.hints = {
		text: "Show Hints",
		checked: Settings.useHints()
	}

    //watch the toggles...prolly not hte best way but works for now
    $scope.$watch('toggleList[0].checked', function() {
        Settings.setChartLabels($scope.toggleList[0].checked);
    }, true);

    $scope.$watch('toggleList[1].checked', function() {
        Settings.setPercentageLabels($scope.toggleList[1].checked);
    }, true);
	
	$scope.$watch('autoBackups.checked', function () {
		Settings.setAutoBackups($scope.autoBackups.checked);
		DBackUp.turnOnBackUps($scope.autoBackups.checked);
	}, true);
	
	$scope.$watch('hints.checked', function() {
        Settings.setHints($scope.hints.checked);
    }, true);

/*
    $scope.clearDB = function() {
        Settings.clear();
    }
	
	$scope.backUp = function () {
		DBackUp.createBackUp();
	}
	
	$scope.restore = function () {
		DBackUp.runRestore();
	}
	*/
});